searchNodes=[{"ref":"EtcdClient.html","title":"EtcdClient","type":"module","doc":"This module provides basic ETCD watch, lease, and kv functionality, it is incomplete and still in development. Opens a grpc connection channel to etcd with hostname and port provided in &#39;opts&#39; keyword list. Registers the channel with name provided in &#39;opts&#39; keyword list. To start from a supervisor: add to config.exs: config :myapp, etcd: [ hostname: &quot;localhost&quot;, port: &quot;2379&quot; ] Add to supervisor child list: {EtcdClient, [Keyword.put(Application.get_env(:myapp, :etcd), :name, ETCD)]} To use above connection pass the name you provided as the &#39;conn&#39; argument to EtcdClient functions: {:ok, response} = EtcdClient.put_kv_pair(ETCD, key, value) To establish an etcd lease and associate a kv pair: {:ok, response} = EtcdClient.start_lease(ETCD, lease_id, time_to_live) {:ok, pid} = EtcdClient.keep_lease_alive(ETCD, lease_id, keep_alive_interval) {:ok, response} = EtcdClient.put_kv_pair(ETCD, key, value, lease_id) To establish an etcd watch over a range of keys: {:ok, pid} = EtcdClient.start_watcher(ETCD, watcher_id, from) EtcdClient.add_watch(start_range, end_range, watcher_id, watch_id) Events recieved by the watcher will be sent to the pid provided in the from argument, to retrieve them if using a GenServer add: def handle_info({:watch_event, event} , state) do watch_response = elem(event, 1) Enum.each(watch_response.events, fn(e) -&gt; process_watch_event(e) end) {:noreply, 1} end If using the latest master branch of etcd (3.3+git) you can add multiple watches to the same watcher. Older versions will ignore the watch_id and you will need to start a separate watcher(with unique ids) for each individual watch. For more information on etcd request and response types see the generated proto files in /lib/priv on github."},{"ref":"EtcdClient.html#add_lock/3","title":"EtcdClient.add_lock/3","type":"function","doc":""},{"ref":"EtcdClient.html#add_watch/2","title":"EtcdClient.add_watch/2","type":"function","doc":"Adds a watch to EtcdClient.Watcher with given &#39;watcher_id&#39; using provided &#39;watch_create_request&#39;"},{"ref":"EtcdClient.html#add_watch/4","title":"EtcdClient.add_watch/4","type":"function","doc":"Adds an etcd watch on key range to the EtcdClient.Watcher with given &#39;watcher_id&#39;. Function to start a basic watch with default etcd options"},{"ref":"EtcdClient.html#cancel_watch/2","title":"EtcdClient.cancel_watch/2","type":"function","doc":"Sends a watch cancel request to etcd on the stream for provided &#39;watcher_id&#39; to cancel the watch with provided &#39;watch_id&#39;"},{"ref":"EtcdClient.html#child_spec/1","title":"EtcdClient.child_spec/1","type":"function","doc":""},{"ref":"EtcdClient.html#close_connection/1","title":"EtcdClient.close_connection/1","type":"function","doc":"Closes and unregisters the grpc connection registered under &#39;conn&#39;"},{"ref":"EtcdClient.html#delete_kv_pair/2","title":"EtcdClient.delete_kv_pair/2","type":"function","doc":"Sends a delete range request to etcd on grpc channel registered under &#39;conn&#39; deleting the kv pair associated with &#39;key&#39;. Returns {:ok, number_off_keys_deleted}"},{"ref":"EtcdClient.html#delete_kv_range/2","title":"EtcdClient.delete_kv_range/2","type":"function","doc":"Sends a delete range request to etcd using provided &#39;delete_range_request&#39; and returns the full delete range response. Use this function if you need the full response"},{"ref":"EtcdClient.html#delete_kv_range/3","title":"EtcdClient.delete_kv_range/3","type":"function","doc":"Sends a delete range request to etcd on grpc channel registered under &#39;conn&#39; deleting the kv range between &#39;key&#39; and &#39;range&#39;. Returns {:ok, number_of_keys_deleted}"},{"ref":"EtcdClient.html#get_kv_pair/2","title":"EtcdClient.get_kv_pair/2","type":"function","doc":"Sends a range request to etcd on grpc channel registered under &#39;conn&#39;. Returns the kv pair associated with &#39;key&#39; if it exists in the form of a list of key/value/lease maps"},{"ref":"EtcdClient.html#get_kv_range/2","title":"EtcdClient.get_kv_range/2","type":"function","doc":"Sends a range request to etcd using provided &#39;range_request&#39; and returns the full etcd range response. Use this function if you need the full range response"},{"ref":"EtcdClient.html#get_kv_range/3","title":"EtcdClient.get_kv_range/3","type":"function","doc":"Sends a range request to etcd on grpc channel registered under &#39;conn&#39;. Returns the kv range between &#39;key&#39; and &#39;range&#39; if any exist in the form of a list of key/value/lease maps"},{"ref":"EtcdClient.html#get_leases/1","title":"EtcdClient.get_leases/1","type":"function","doc":"Returns all active leases on the given etcd &#39;conn&#39; as a list of lease_ids"},{"ref":"EtcdClient.html#keep_lease_alive/3","title":"EtcdClient.keep_lease_alive/3","type":"function","doc":"Starts an EtcdClient.Lease. EtcdClient.Lease opens an etcd lease keep alive stream and sends keep alive requests for given &#39;id&#39; every &#39;keep_alive_interval&#39; in miliseconds"},{"ref":"EtcdClient.html#kill_watcher/1","title":"EtcdClient.kill_watcher/1","type":"function","doc":""},{"ref":"EtcdClient.html#put_kv_pair/2","title":"EtcdClient.put_kv_pair/2","type":"function","doc":"Sends a PUT request to etcd with provided &#39;put_request&#39; and returns full put response. Use this function if you need prev_kv data or the full put response"},{"ref":"EtcdClient.html#put_kv_pair/3","title":"EtcdClient.put_kv_pair/3","type":"function","doc":"Sends a put request to etcd on grpc channel registered under &#39;conn&#39; with &#39;key&#39; and &#39;value&#39; as the key value pair to be put. Returns {:ok, %{key, value}}"},{"ref":"EtcdClient.html#put_kv_pair/4","title":"EtcdClient.put_kv_pair/4","type":"function","doc":"Sends a PUT request to etcd on grpc channel registered under &#39;conn&#39; with &#39;key&#39; and &#39;value&#39; as the key value pair to be put and assigined to the lease provided in &#39;lease_id&#39; Returns {:ok, %{key, value, lease}}"},{"ref":"EtcdClient.html#revoke_lease/2","title":"EtcdClient.revoke_lease/2","type":"function","doc":"Revokes an etcd lease with the given &#39;id&#39; and kills it&#39;s keep alive process if it exists"},{"ref":"EtcdClient.html#start_lease/2","title":"EtcdClient.start_lease/2","type":"function","doc":"Sends a lease grant request to etcd on grpc channel registered under &#39;conn&#39; with time to live &#39;ttl&#39; Returns {:ok, %{lease_id, lease_ttl, error}}"},{"ref":"EtcdClient.html#start_lease/3","title":"EtcdClient.start_lease/3","type":"function","doc":"Sends a lease grant request to etcd on grpc channel registered under &#39;conn&#39; with &#39;id&#39; and time to live &#39;ttl&#39; Returns {:ok, %{lease_id, lease_ttl, error}}"},{"ref":"EtcdClient.html#start_link/1","title":"EtcdClient.start_link/1","type":"function","doc":""},{"ref":"EtcdClient.html#start_watcher/3","title":"EtcdClient.start_watcher/3","type":"function","doc":"Starts an EtcdClient.Watcher with the given &#39;id&#39;. Opens an etcd watch stream that etcd watches can be added to. EtcdClient.Watcher supports multiple etcd watches on a single stream. If more than one stream is needed start another EtcdClient.Watcher with a different id. Watch events will be sent to the pid provided in the from argument."},{"ref":"EtcdClient.Lease.html","title":"EtcdClient.Lease","type":"module","doc":""},{"ref":"EtcdClient.Lease.html#child_spec/1","title":"EtcdClient.Lease.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"EtcdClient.Lease.html#start_link/1","title":"EtcdClient.Lease.start_link/1","type":"function","doc":""},{"ref":"EtcdClient.Lease.html#t:t/0","title":"EtcdClient.Lease.t/0","type":"type","doc":""},{"ref":"EtcdClient.WatchListener.html","title":"EtcdClient.WatchListener","type":"module","doc":""},{"ref":"EtcdClient.WatchListener.html#child_spec/1","title":"EtcdClient.WatchListener.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. arg is passed as the argument to Task.start_link/1 in the :start field of the spec. For more information, see the Supervisor module, the Supervisor.child_spec/2 function and the Supervisor.child_spec/0 type."},{"ref":"EtcdClient.WatchListener.html#run/1","title":"EtcdClient.WatchListener.run/1","type":"function","doc":""},{"ref":"EtcdClient.WatchListener.html#start_link/1","title":"EtcdClient.WatchListener.start_link/1","type":"function","doc":""},{"ref":"EtcdClient.Watcher.html","title":"EtcdClient.Watcher","type":"module","doc":""},{"ref":"EtcdClient.Watcher.html#child_spec/1","title":"EtcdClient.Watcher.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"EtcdClient.Watcher.html#get_stream/1","title":"EtcdClient.Watcher.get_stream/1","type":"function","doc":""},{"ref":"EtcdClient.Watcher.html#kill_watcher/1","title":"EtcdClient.Watcher.kill_watcher/1","type":"function","doc":""},{"ref":"EtcdClient.Watcher.html#send_watch_event/2","title":"EtcdClient.Watcher.send_watch_event/2","type":"function","doc":""},{"ref":"EtcdClient.Watcher.html#send_watch_request/2","title":"EtcdClient.Watcher.send_watch_request/2","type":"function","doc":""},{"ref":"EtcdClient.Watcher.html#set_stream/2","title":"EtcdClient.Watcher.set_stream/2","type":"function","doc":""},{"ref":"EtcdClient.Watcher.html#start_link/1","title":"EtcdClient.Watcher.start_link/1","type":"function","doc":""},{"ref":"EtcdClient.Watcher.html#start_listener/1","title":"EtcdClient.Watcher.start_listener/1","type":"function","doc":""},{"ref":"EtcdClient.Watcher.html#t:t/0","title":"EtcdClient.Watcher.t/0","type":"type","doc":""}]